﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;


namespace TcpLobby
{

    public partial class frmStatus : Form
    {
        public static TcpListener posluchac;
        public static object parovac = new object();
        public static List<Klient> klienti = new List<Klient>();
        
        public static long poradi = 0;
        public static int bufsize = 1024;

        public frmStatus()
        {
            InitializeComponent();
        }

        private void startListening()
        {
            posluchac = new TcpListener(IPAddress.Parse(txtIP.Text), int.Parse(txtPort.Text));
            posluchac.Start();
            enableAccept();
            button1.Enabled = false;
            txtIP.Enabled = false;
            txtPort.Enabled = false;
            tmrGrid.Start();
        }

        public static void enableAccept()
        {
            posluchac.BeginAcceptTcpClient(new AsyncCallback(acceptCallback), posluchac);
        }

        public static void acceptCallback(IAsyncResult ar)
        {
            // wait for another
            enableAccept();
            
            // init client
            poradi++;
            Klient klient = new Klient(poradi);
            TcpClient tcpKlient = posluchac.EndAcceptTcpClient(ar);
            klient.stream = tcpKlient.GetStream();
            
            // add self to pool
            klienti.Add(klient);

            // find partner if possible
            findPartner(klient);
            
            // read data
            while (true)
            {
                byte[] buf = new byte[bufsize];
                int delka = 0;
                try
                {
                    delka = klient.stream.Read(buf, 0, buf.Length);
                }
                catch
                {
                }

                if (delka == 0)
                {
                    // read failed, treat connection as dead
                    break;
                }

                if (klient.id_par != 0)
                {
                    klienti.FirstOrDefault(w => w.id == klient.id_par).stream.Write(buf, 0, delka);
                    klient.sent += delka;

                }
            }
            // unpair counterpart if any
            if (klient.id_par != 0)
                klienti.FirstOrDefault(w => w.id_par == klient.id).id_par = 0;
            
            // remove self from pool
            klienti.Remove(klient);

            tcpKlient.Close();
        }

        public static void findPartner(Klient newbie)
        {
            // pairing procedure
            lock (parovac)
            {
                // find another lonely client
                Klient part = klienti.FirstOrDefault(w => w.id_par == 0 && w != newbie);
                if (part != null)
                {
                    // if found pair them up
                    part.id_par = newbie.id;
                    newbie.id_par = part.id;
                }
            }
        }

        public void redrawGrid()
        {
            grdPartners.Rows.Clear();
            foreach (Klient kl in klienti)
            {
                grdPartners.Rows.Add(kl.id, kl.id_par, kl.sent);
            }
            grdPartners.Refresh();
        }

        private void tmrGrid_Tick(object sender, EventArgs e)
        {
            redrawGrid();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            startListening();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            string[] argy = Environment.GetCommandLineArgs();
            if (argy.Length == 3)
            {
                txtIP.Text = argy[1];
                txtPort.Text = argy[2];
                startListening();
            }
        }

    }

    public class Klient
    {
        public NetworkStream stream;
        public long id;
        public long id_par;
        public long sent;

        public Klient(long idc)
        {
            stream = null;
            id = idc;
            id_par = 0;
            sent = 0;
        }
    }

}
